<template lang="pug">
loader(:loading='!firebaseloading' title='Building visualization...')
  .q-pt-md.q-mb-lg(v-if='meeting')
    .q-pa-md
      q-breadcrumbs
        q-breadcrumbs-el(icon='home' to='/')
        q-breadcrumbs-el(:label='meeting.topic' icon='insert_invitation' :to='\'/\' + meeting[\'.key\']')
        q-breadcrumbs-el(icon='pie_chart')
          q-btn-dropdown(style='font-weight: normal' type='a' label='Visualisation' no-caps flat)
            q-list
              q-item(:to='\'/managedocs/\' + meeting[\'.key\']') Documents
        q-breadcrumbs-el(v-if='history == 0' style='color: red' label='Live' icon='play_arrow')
        q-breadcrumbs-el(v-if='history != 0' label='History' icon='history')
        q-breadcrumbs-el(v-if='history != 0' :label='historyTime(history)')


      .text-h4.q-pt-md.row
        div Visualisation
        q-space
        q-btn(round, flat, icon="more_vert")
          q-menu
            q-list
              q-item.row(
                clickable,
                @click="showLogs = true",
                v-close-popup
              )
                q-item-section.col-auto(avatar)
                  q-icon(name="receipt_long")
                q-item-section.col-auto View Logs
      .q-py-md

        q-banner.text-center.bg-primary.q-my-md.text-white(v-if='step === 0 && !meeting.actualEndTime')
          template(v-slot:avatar)
            q-icon(name='history')
          span.vertical-middle.text-body1 This view shows data from the previous 5 minutes of the class.

        .row.justify-center(v-if="visType == 'gdoc'")
          q-btn(v-on:click='manageDocs' flat color='primary' style='align: center') Manage Documents

        .row.q-mt-md
          .col-md.col-12
            .text-h6.q-mb-lg {{ boLength(TimeRange) }}
            .row.fit.q-col-gutter-md
              RoomSpeakers.col-lg-4.col-md-6.col-xs-12.self-stretch(:visType="visType" v-for="(speakerData, key) in activeSpeakersSortedByDisabled" :title="ifBOSessionTitle(key)" :key="key" :disabled="roomSpeakersIsDisabled(speakerData)" :activeSpeakers="speakerData" :distributedDocs="distributedDocs ? distributedDocs[speakerData['.key']] : []" :history="history" :meeting="meeting" :user="user", :requestDownloadSpeakerData="handleDownloadSpeakerData")
          .col-md-2.col-12(:class="{'order-first':$q.screen.lt.md}")
            q-select(dense emit-value outlined :options="visOptions" v-model="visType" map-options)
              template(v-slot:prepend)
                q-icon(name="pie_chart" color="primary")

            q-stepper(alternative-labels flat v-model='step' ref='stepper' color='primary' animated vertical @input='navTo(step)' :header-nav='true')
              q-step(:header-nav='false' name='start' :title='`Started (${StartTime})`' icon='play_arrow')
              q-step(:done-icon='getTimelineIcon(h)' :active-icon='getTimelineIcon(h)' :done='h == history' v-for='h in historyList' :key='h' :name='h' :title='getTimelineTitle(h)' :icon='getTimelineIcon(h)')
              q-step(v-if='!meeting.actualEndTime' done-icon='play_arrow' active-icon='play_arrow' active-color='red-7' :done='history == 0' :name='0' title='Live' icon='play_arrow')
              q-step(v-if='meeting.actualEndTime' done-icon='stop' active-icon='stop' :name='-1' :title='EndTime' icon='stop' :header-nav='false')
  q-page-sticky(position="bottom-right", :offset="[18, 18]")
    GlobalChats(:meetingKey="meeting['.key']", :allowSending="meeting.actualStartTime && !meeting.actualEndTime && isBOSession(history)")

  q-dialog(v-model="showLogs")
    q-card(style="min-width: 40%; min-height: 40%")
      q-card-section
        .text-h5 Logs
      q-card-section
        q-list(v-if="logs", bordered, separator)
          q-item(v-for="(log, index) in logs", :key="index")
            q-item-section.col
              .text-bold {{ log.timestamp }}
              div.text-normal {{ log.text }}
        .full-width.full-height.text-center(v-else) No Logs Yet

</template>

<script>
import { db } from "../db";
import { roundHistory, lookupRealHistory, download } from "../shared";
import moment from "moment";
import RoomSpeakers from "@/components/RoomSpeakers.vue";
import Loader from "@/components/Loader.vue";
import GlobalChats from "@/components/GlobalChats.vue";

const meetings = db.ref("meetings");
const activeSpeakers = db.ref("data/activeSpeakers");

export default {
  name: "MeetingDetails",
  props: { history: { default: 0 }, user: {} },
  data: function () {
    return {
      meeting: {},
      activeSpeakers: [],
      chats: { loading: true },
      distributedDocs: {},
      firebaseloading: true,
      step: 0,
      timezone: moment.tz.guess(),
      visType: "piechart",
      visOptions: [
        {
          label: "Active Speakers",
          value: "piechart",
        },
        {
          label: "Network Diagram",
          value: "network",
        },
        {
          label: "Timeline Visualization",
          value: "timeline",
        },
        {
          label: "Google Document Editing",
          value: "gdoc",
        },
      ],
      showLogs: false,
    };
  },
  watch: {
    history: {
      immediate: true,
      handler(h) {
        if (h == 0 && this.meeting && this.meeting.actualEndTime) {
          this.$router.push(
            `/${this.meeting[".key"]}/${
              this.historyList[this.historyList.length - 1]
            }`,
          );
        }

        if (h == "") {
          this.step = 0;
        }
      },
    },
    meetingId: {
      immediate: true,
      async handler(id) {
        if (this.user) {
          const anonymous = this.$cookies.get("anonymous");

          if (!anonymous) {
            await this.$rtdbBind(
              "meeting",
              meetings.child(this.user.uid).child(id),
            );
          } else {
            this.meetingid = anonymous.meetingid;

            await this.$rtdbBind(
              "meeting",
              meetings.child(anonymous.hostuid).child(this.meetingid),
            );
          }

          await this.$rtdbBind("chats", db.ref(`data/chats/${id}`));
          await this.$rtdbBind("activeSpeakers", activeSpeakers.child(id));

          var docsRef = db.ref(`data/gdocs/${id}`);
          docsRef.on("value", snapshot => {
            this.distributedDocs = snapshot.val();
          });

          this.firebaseloading = false;

          if (this.meeting.actualEndTime && this.history == 0) {
            this.$router.replace(
              `/${id}/${this.historyList[this.historyList.length - 1]}`,
            );
          }
        } else {
          if (this.$router.currentRoute.path != "/") {
            this.$router.push("/");
          }
          location.reload();
        }
      },
    },
  },
  computed: {
    meetingId() {
      return this.$route.params.id;
    },
    TimeRange: function () {
      try {
        let events = [];

        var initialLatestTime = -1;
        var initialEarliestTime = 9999999999999999999;

        // find the latest and earliest timestamp from each bot
        let latesttime = initialLatestTime;
        let earliestime = initialEarliestTime;

        for (let bot of this.activeSpeakers) {
          let rh = lookupRealHistory(this.history, bot.history);

          if (rh != -1 && rh > latesttime) latesttime = rh;

          if (this.history == 0) {
            if (bot.current) events = Object.values(bot.current.activeHistory);
          } else if (bot && bot.history && bot.history[rh]) {
            events = Object.values(bot.history[rh].activeHistory);
          } else {
            // nothing
          }

          if (events.length >= 1) {
            let _botlatest = this.latestTime(events);

            if (_botlatest[1] < earliestime) earliestime = _botlatest[1];
          }
        }

        if (
          latesttime === initialLatestTime &&
          earliestime === initialEarliestTime
        ) {
          // if nothing is set, make sure we put a valid date in
          latesttime = new Date(this.meeting.startTime);
          earliestime = new Date(this.meeting.endTime);
        }

        return [latesttime, earliestime];
      } catch (e) {
        return [0, 0];
      }
    },
    EndTime: function () {
      return moment(this.meeting.actualEndTime)
        .tz(this.timezone)
        .format("h:mma");
    },
    StartTime: function () {
      return moment(this.meeting.startTime).tz(this.timezone).format("h:mma");
    },
    MeetingLength: function () {
      var duration = moment.duration(
        moment(new Date(this.meeting.endTime)).diff(
          moment(new Date(this.meeting.startTime)),
        ),
      );
      return duration.asMinutes();
    },
    TimeString: function () {
      var now = new Date();
      var starts = new Date(this.meeting.startTime);
      var ends = new Date(this.meeting.endTime);

      var startString = moment(new Date(this.meeting.startTime))
        .tz(this.timezone)
        .fromNow();

      if (ends < now) {
        return (
          "Class ended " +
          moment(new Date(this.meeting.endTime)).tz(this.timezone).fromNow()
        );
      }
      if (starts < now) {
        return "Started " + startString;
      }

      return "Starts " + startString;
    },
    historyList: function () {
      const allHistory = new Set();

      this.activeSpeakers.forEach(zoomBotWithHistory => {
        if (!zoomBotWithHistory.history) return;
        for (const historyKey in zoomBotWithHistory.history) {
          // We only add a history node if it has a userlist
          if (zoomBotWithHistory.history[historyKey].userList) {
            allHistory.add(roundHistory(historyKey));
          }
        }
      });

      return [...(allHistory || [])].sort();
    },
    activeSpeakersSortedByDisabled() {
      return [...(this.activeSpeakers || [])].sort(
        (a, b) =>
          this.roomSpeakersIsDisabled(a) - this.roomSpeakersIsDisabled(b),
      );
    },
    logs() {
      const result = [];

      for (const zoomBot in this.chats) {
        for (const chatKey in this.chats[zoomBot]) {
          if (
            (this.chats[zoomBot][chatKey].msgSenderName || "").startsWith(
              "ZoomSensor_",
            )
          ) {
            result.push({
              text: `${zoomBot} sent message "${
                this.chats[zoomBot][chatKey].msg
              }" to ${
                this.chats[zoomBot][chatKey].msgReceiver !== 0
                  ? this.chats[zoomBot][chatKey].msgReceiverName
                  : " everyone"
              }${
                this.chats[zoomBot][chatKey].isInBO
                  ? " while in a breakout room"
                  : ""
              }`,
              timestamp: moment(this.chats[zoomBot][chatKey].timestamp).format(
                "ddd D MMM YYYY hh:mm",
              ),
            });
          }
        }
      }

      return result;
    },
  },
  methods: {
    manageDocs() {
      this.$router.push("/managedocs/" + this.meetingId);
    },
    latestTime(botevents) {
      let sorted = botevents.map(f => f.timestamp).sort();
      return [sorted[sorted.length - 1], sorted[0]];
    },
    boLength(bo) {
      if (this.history == 0) {
        return `${moment
          .unix(bo[1] / 1000)
          .tz(this.timezone)
          .format("h:mma")} - Now (${moment
          .duration(moment().diff(moment.unix(bo[1] / 1000)))
          .humanize()})`;
      } else
        return `${moment
          .unix(bo[1] / 1000)
          .tz(this.timezone)
          .format("h:mma")} - ${moment
          .unix(bo[0] / 1000)
          .tz(this.timezone)
          .format("h:mma")} (${moment
          .duration(moment.unix(bo[0] / 1000).diff(moment.unix(bo[1] / 1000)))
          .humanize()})`;
    },
    navTo(h) {
      if (h == 0) h = "";
      this.$router.push("/" + this.meeting[".key"] + "/" + h);
    },
    historyTime(h) {
      let events = [];

      // lookup the earliest first event for any of the bots
      // (as this timestamp is the *endtime* of the BO session)
      let earliestime = 9999999999999999999;

      for (let bot of this.activeSpeakers) {
        let real = this.realhistoryindex(bot, h);
        if (
          bot &&
          bot.history &&
          bot.history[real] &&
          bot.history[real].activeHistory
        ) {
          events = Object.values(bot.history[real].activeHistory);
        } else {
          // nothing
        }

        if (events.length >= 1) {
          let _botlatest = this.latestTime(events);
          if (_botlatest[1] < earliestime) earliestime = _botlatest[1];
        }
      }

      let dd = moment.duration(
        moment.unix(earliestime / 1000).diff(moment(this.meeting.startTime)),
      );

      return `${dd.hours() != 0 ? dd.hours() + "h, " : ""}${dd.minutes()}m`;
    },
    ifBOSessionTitle(index) {
      if (index == 0) {
        return this.isBOSession(this.history) ? "" : "Main Class";
      } else return "";
    },
    getTimelineIcon(h) {
      return this.isBOSession(h) ? "group_work" : "people";
    },
    getTimelineTitle(h) {
      var category = this.isBOSession(h) ? "Breakouts" : "Main";
      var minutesLength = 0;

      var historyIndex = this.historyList.indexOf(h);

      // get segment length in minutes
      if (historyIndex == 0) {
        minutesLength =
          (h - moment(this.meeting.startTime).valueOf()) / 1000 / 60;
      } else {
        minutesLength = (h - this.historyList[historyIndex - 1]) / 1000 / 60;
      }

      return category + " (" + minutesLength + " mins)";
    },
    isBOSession(h) {
      let hashistory = this.realhistoryindex(this.activeSpeakers[0], h);
      if (
        hashistory != -1 &&
        this.activeSpeakers &&
        this.activeSpeakers[0] &&
        this.activeSpeakers[0].history &&
        !this.activeSpeakers[0].history[hashistory].isInBO
      ) {
        return false;
      } else if (
        (hashistory == 0 || hashistory == -1) &&
        this.activeSpeakers[0] &&
        this.activeSpeakers[0].current &&
        !this.activeSpeakers[0].current.isInBO
      ) {
        return false;
      }
      return true;
    },

    meetingFinished() {
      return moment(this.meeting.endTime).toDate() < moment().toDate();
    },

    realhistoryindex(bot, index) {
      // loop through and find the key that matches:
      if (bot.history) {
        let keys = Object.keys(bot.history);
        for (let el of keys) {
          if (roundHistory(el) == parseInt(index)) {
            return el;
          }
        }
        return -1;
      } else {
        return 0;
      }
    },
    handleDownloadSpeakerData(realHistory, activeSpeakers) {
      download(
        `${this.meeting.topic} (${this.boLength(
          this.TimeRange,
        )}) - Speaker Data.json`,
        JSON.stringify(activeSpeakers.history[realHistory], null, 4),
      );
    },
    roomSpeakersIsDisabled(activeSpeakers) {
      if (this.visType === "gdoc") return false;

      const realHistory = lookupRealHistory(
        this.history,
        activeSpeakers.history,
      );

      if (
        // If we can't find the real history for this history value, and we don't have a current node
        // This is the case where the visualisation is live
        ((realHistory == -1 || realHistory == 0) &&
          (!activeSpeakers.current ||
            !activeSpeakers.current.activeHistory ||
            Object.keys(activeSpeakers.current.activeHistory).length <= 1)) ||
        // Otherwise, if the visualisation is historical, we make sure we have history, and it exists
        // in the history and it has a user list, and it has some history
        (realHistory != 0 &&
          realHistory != -1 &&
          (!activeSpeakers.history ||
            !activeSpeakers.history[realHistory] ||
            !activeSpeakers.history[realHistory].userList ||
            Object.keys(activeSpeakers.history[realHistory].activeHistory)
              .length <= 1))
      )
        return true;

      return false;
    },
  },
  components: {
    RoomSpeakers,
    Loader,
    GlobalChats,
  },
  created: function () {
    this.step = this.history;
  },
};
</script>

<style>
.meetingPage {
  margin-top: 1em;
}

.q-stepper--horizontal .q-stepper__step-inner {
  display: none !important;
}
</style>
